local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Mine1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Part/Crane.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Part/Pile.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Part/Wheelbarrow.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Constr/Step_0.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Constr/Step_1.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Constr/Step_2.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Constr/Step_3.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Constr/Step_4.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Constr/Step_5.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/IronMine.Constr/Step_6.001", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Part/Crane.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Part/Pile.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Part/Wheelbarrow.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Constr/Step_0.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Constr/Step_1.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Constr/Step_2.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Constr/Step_3.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Constr/Step_4.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/GoldMine.Constr/Step_5.002", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Part/Marble.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Part/Marble.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Part/Wheelbarrow.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Part/Torch.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Part/Torch.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Constr/Step_0.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Constr/Step_1.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Constr/Step_2.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Constr/Step_3.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/MarbleMine.Constr/Step_4.003", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Part/Quartz.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Part/Wheelbarrow.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Part/Bucket.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Part/Bucket.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Part/Bucket.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Part/Bucket.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Constr/Step_0.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Constr/Step_1.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Constr/Step_2.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Constr/Step_3.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Constr/Step_4.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Mine1.fbx/Prefab/QuartzMine.Constr/Step_5.004", {DataType = "COMP_GROUNDED"})



-- Building -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "BUILDING",
	Id = "BUILDING_TIBERIAS_QUARRY",
	Name = "BUILDING_TIBERIAS_QUARRY_NAME",
	Description = "BUILDING_TIBERIAS_QUARRY_DESC",
	BuildingType = "RESOURCE_PRODUCTION",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
    AssetMiniatureBuildingPart = "BUILDING_PART_TIBERIAS_QUARRY_IRON",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_TIBERIAS_QUARRY_1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TIBERIAS_QUARRY_IRON",
				"BUILDING_PART_TIBERIAS_QUARRY_GOLD",
				"BUILDING_PART_TIBERIAS_QUARRY_QUARTZ",
				"BUILDING_PART_TIBERIAS_QUARRY_MARBLE",
			}
		},
		-- {
		-- 	Name = "BUILDING_SET_TIBERIAS_QUARRY_2_NAME",
		-- 	BuildingPartList = { 
		-- 		"BUILDING_PART_QUARRY_CRANE",
		-- 	}
		-- },
		{
			Name = "BUILDING_SET_TIBERIAS_QUARRY_3_NAME",
			BuildingPartList = { 
				"BUILDING_PART_QUARRY_CART",
                "BUILDING_PART_QUARRY_ROCK_HOLDER",
			}
		},
    },
	-- RequiredPartList = {
		-- { Category = "QUARRY", Min = 1, Max = 1 },
		-- { Category = "RESOURCE_DEPOT", Min = 1, Max = 1 },
	-- },
	VillagerRequired = { Status = "COMMONER", Quantity = 1 },
	IsEditable = true,
})



-- Building Part -------------------------------------------------------------------------------------
function registerPart(meshName, constrName, partName, buildingZone, categoryName, cost, resourceName)

    -- Prefab
    mod:registerAssetId("models/Mine1.fbx/Prefab/" .. meshName, "PREFAB_TIBERIAS_QUARRY_" .. partName)
    mod:registerAssetId("models/Mine1.fbx/Prefab/" .. constrName, "PREFAB_TIBERIAS_QUARRY_" .. partName .. "_CONSTR")

    -- Building Part
    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_TIBERIAS_QUARRY_" .. partName,
        Name = "BUILDING_PART_TIBERIAS_QUARRY_" .. partName .. "_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_TIBERIAS_QUARRY_" .. partName,
        },
        ConstructionVisual = "PREFAB_TIBERIAS_QUARRY_" .. partName .. "_CONSTR",
        BuildingZone = buildingZone,
        Category = categoryName,
        Cost = cost,
        AssetBuildingFunction = "BUILDING_FUNCTION_TIBERIAS_QUARRY_" .. partName,
    })

    -- Building Function
    mod:registerAsset({
        DataType = "BUILDING_FUNCTION_WORKPLACE",
        Id = "BUILDING_FUNCTION_TIBERIAS_QUARRY_" .. partName,
        Name = "BUILDING_PART_TIBERIAS_QUARRY_" .. partName .. "_NAME",
        WorkerCapacity = 4,
        RelatedJob = { 
            Job = "MINER",
            Behavior = "BEHAVIOR_GATHER"
        },
        InputInventoryCapacity = {
        },
        ResourceListNeeded = {
            { Resource = resourceName, Quantity = 1 },
        },
        ResourceProduced = {
            { Resource = resourceName, Quantity = 1 },
        }
    })


end

_buildingZone1 = { ZoneEntryList = { { Polygon = polygon.createCircle( 2.5, { 0, 0 }, 16 ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_costMine = { BuildRightTaxes = { { Resource = "GOLD_COINS", Quantity = 20 } }, UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 20 } }, ResourceNeededList = {
            { { Resource = "WOOD", Quantity = 6 }, { Resource = "PLANK", Quantity = 6 }, { Resource = "TOOL", Quantity = 4 }, } } }

registerPart("IronMine.Part", "IronMine.Constr", "IRON", _buildingZone1, "QUARRY", _costMine, "IRON_ORE")
registerPart("GoldMine.Part", "GoldMine.Constr", "GOLD", _buildingZone1, "QUARRY", _costMine, "GOLD_ORE")
registerPart("MarbleMine.Part", "MarbleMine.Constr", "MARBLE", _buildingZone1, "QUARRY", _costMine, "MARBLE")
registerPart("QuartzMine.Part", "QuartzMine.Constr", "QUARTZ", _buildingZone1, "QUARRY", _costMine, "QUARTZ")



